package com.scientificCalculaor.view
{
	import flash.events.MouseEvent;
	import flash.text.ReturnKeyLabel;
	import flash.ui.Mouse;
	import flash.utils.clearInterval;
	import flash.utils.setInterval;
	
	import flashx.textLayout.formats.Float;
	
	import mx.collections.ArrayCollection;
	import mx.controls.ComboBase;
	import mx.events.ModuleEvent;
	import mx.rpc.events.ResultEvent;
	
	import org.robotlegs.mvcs.Mediator;
	
	import spark.events.IndexChangeEvent;
	import spark.skins.spark.windowChrome.MacCloseButtonSkin;
	
	public class scientificCalculatorMediator extends Mediator
	{
		
		[Inject]public var view:scientificCalculatorView;
		
		private var i:Number; 
		private var c:String;
		private var inString : String;
		private var junkString : String = " <-- Extra Junk";	// error string
		private var removeInt : Number;
		private var stack : Array;
		private var errorMessage : String = '';
		
		private var digitFlag:Boolean;
		private var equalFlag:Boolean;
		private var total:String;
		
		private var dotFlag:Boolean;
		[Bindable]
		private var memArray:ArrayCollection=new ArrayCollection();
		
		private var logFlag:Boolean;
		private var sqrtFlag:Boolean;
		
		private var logBaseXFlag:Boolean=false;
		private var newV:Number;
		
		private var sqrootXFlag:Boolean=false;
		
		public function scientificCalculatorMediator()
		{
			super();
		}
		override public function onRegister():void
		{
			eventMap.mapListener(view.d0,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d1,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d2,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d3,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d4,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d5,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d6,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d7,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d8,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.d9,MouseEvent.CLICK,digitClicked);
			
			eventMap.mapListener(view.add,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.sub,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.mul,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.div,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.mod,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.lbracket,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.rbracket,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.sin,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.cos,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.tan,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.sinInverse,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.cosInverse,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.tanInverse,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.log,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.ln,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.pi,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.exp,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.sqroot,MouseEvent.CLICK,optClicked);
			
			eventMap.mapListener(view.x2,MouseEvent.CLICK,x2Clicked);
			eventMap.mapListener(view.x3,MouseEvent.CLICK,x3Clicked);
			eventMap.mapListener(view.ypowx,MouseEvent.CLICK,ypowxClicked);
			eventMap.mapListener(view.xfact,MouseEvent.CLICK,xfactClicked);
			
			//not solved
			eventMap.mapListener(view.logx,MouseEvent.CLICK,logxClicked);
			eventMap.mapListener(view.xsqrooty,MouseEvent.CLICK,xsqrootyClicked);
			//not solved
			
			eventMap.mapListener(view.dot,MouseEvent.CLICK,dotClicked);
			eventMap.mapListener(view.c,MouseEvent.CLICK,clearClicked);
			eventMap.mapListener(view.ce,MouseEvent.CLICK,ceClicked);
			eventMap.mapListener(view.equals,MouseEvent.CLICK,equalClicked);
			eventMap.mapListener(view.b,MouseEvent.CLICK,backClicked);
			
			eventMap.mapListener(view.mAdd,MouseEvent.CLICK,addMemClicked);
			eventMap.mapListener(view.mSub,MouseEvent.CLICK,subMemClicked);
			eventMap.mapListener(view.mClear,MouseEvent.CLICK,clearMemClicked);
			//data provider for combobox
			view.combobox.dataProvider = memArray;
			eventMap.mapListener(view.combobox,IndexChangeEvent.CHANGE,comboboxChange);
		}
		
		
		
		private function xsqrootyClicked(event:MouseEvent):void
		{
			appendText("v");
		}
		
		private function logxClicked(event:MouseEvent):void
		{
			appendText("log");
		}
		
		private function xfactClicked(event:MouseEvent):void
		{
			appendText("!");
		}
		
		private function ypowxClicked(event:MouseEvent):void
		{	
			appendText("^");
			digitFlag=false;
		}
		private function x2Clicked(event:MouseEvent):void
		{	
			appendText("^2");
			digitFlag=false;
		}
		private function x3Clicked(event:MouseEvent):void
		{
			appendText("^3");
			digitFlag=false;
		}		
		private function appendText(str:String):void
		{
			var text:String = view.numDisplay.text;
			if(text=="0") text="";
			view.numDisplay.text = text+str;
		}
		private function optClicked(event:MouseEvent):void
		{
			if(equalFlag)
			{
				view.numDisplay.text="";
				equalFlag=false;
			}
			
			var no:String = view.numDisplay.text;
			var no0:String = view.resultDisplay.text;
			var opt:String=event.target.label;
			if(no=="0") no="";
			view.numDisplay.text=no+opt;
			digitFlag = false;
		}
		
		private function digitClicked(event:MouseEvent):void
		{
			if(equalFlag)
			{
				view.numDisplay.text="";
				equalFlag=false;
			}
			var cno:String=event.target.label;
			var no:String=view.numDisplay.text;
			if(no=="0") no="";
			view.numDisplay.text=no+cno;
			digitFlag=true;
			dotFlag=false;
			
		}
		
		
		
		public function equalClicked(event:MouseEvent):void
		{
			inString = view.numDisplay.text;
			inString=inString.replace("v","sqrt");
			inString=inString.replace("log10","log");
			inString=inString.replace("Exp","exp");
			inString=inString.replace("p","pi");
			stack = [];
			total = parse().toString();
			trace("Expression Tree:::"+stack.join("\n"));
			view.resultDisplay.text="="+total;
			memArray.addItem(total);
			if(errorMessage != '')
			{
				view.resultDisplay.text = errorMessage;
			}
			
			equalFlag=true;
			dotFlag=false;
			
		}
		private function comboboxChange(e:IndexChangeEvent):void
		{
			var item:String=view.combobox.selectedItem;
			view.numDisplay.text=item.charAt(1);
			digitFlag=false;
			//dotFlag=false;
			
		}
		private function addMemClicked(e:MouseEvent):void
		{
			var result:String=view.resultDisplay.text;
			if(digitFlag)
			{
				var no1:String=result;
				memArray.addItem(no1);
			}
			else
			{
				var no:String=result.substr(1);
				memArray.addItem(no);
			}
			digitFlag=false;
			dotFlag=true;
		}
		
		private function clearMemClicked(e:MouseEvent):void
		{
			memArray.removeAll();
		}
		
		private function subMemClicked(e:MouseEvent):void
		{
			if(memArray!=null && memArray.length>0)
			{
				memArray.removeItemAt(memArray.length-1);
			}
			else
			{
				view.resultDisplay.text="MemoryArrayWasEmpty";
			}
		}
		public function parse():Number 
		{
			i = 0;
			c = inString.charAt(i);
			var v:Number = getExpression();
			if(c != '')
			{ // there's extra junk at the end
				//Selection.setFocus(view.resultDisplay.text);
				//Selection.setSelection(i, view.resultDisplay.text.length);
				view.numDisplay.text += junkString;
				removeInt = setInterval(removeJunkString, 1000);
			}
			return(v);
		}
		
		public function getExpression()
		{
			var v:Number;
			eatWhiteSpace();
			if(c == '') return("Nothing");
			v = getTerm();
			while('x+-'.indexOf(c) > 0) 
			{
				if(c == '+') 
				{
					match('+');
					v += getTerm();
					stack.push("(+)");
				} 
				if(c == '-') 
				{
					match('-');
					v -= getTerm();
					stack.push("(-)");			
				}
				eatWhiteSpace();
			}
			return(v);
		}
		
		public function getTerm() 
		{
			var v:Number;
			v = getSubTerm();
			eatWhiteSpace();
			while('x*/%'.indexOf(c) > 0) 
			{
				if(c == '*') 
				{
					match('*');
					v *= getSubTerm();
					stack.push("(*)");			
				}
				if(c == '/') 
				{
					match('/');
					v /= getSubTerm();
					stack.push("(/)");			
				}
				if(c == '%')
				{
					match('%');
					v%=getSubTerm();
					stack.push("(%)");
				}
				eatWhiteSpace();
			}
			return(v);
		}
		
		
		public function getSubTerm() 
		{
			var v:Number;
			v = getAtom();
			eatWhiteSpace();
			if(c == '^') 
			{	
				match('^');
				// this recursion treats ^ as right-associative
				v = Math.pow(v, getSubTerm() );
				stack.push("(^)");			
			}
			if(c == '!')
			{
				match('!');
				var factorial:Number=1;
				var i:Number=1;
				while (i <=v ) 
				{
					factorial = factorial * i;
					i = i+1;
				}
				v=factorial;
			}
			/*if(c == 'log')
			{
				trace(v+"::"+c);
				var index1:Number=v;
				var index2:Number=getTerm();
				//var logBase:String=logx.substr(3,index1-3);
				//var logValue:String=logx.substr(index1+1,index2);
				v=(Math.log(index1))/(Math.log(index2));
				trace(v+"ASDF");
				
				
			}*/
			if(c == 'v')
			{
				var no1:Number=v;
				var no2:Number=getSubTerm();
				v=Math.pow(no2,1/no1);
			}
			return(v);
		}
		
		public function getAtom() 
		{
			var v:Number;
			eatWhiteSpace();
			if(c == '-') 
			{
				match('-');
				v = getSubTerm();
				stack.push("neg");		
				return(-1 * v);
			}
			if(c == '(') 
			{
				match('(');
				v = getExpression();
				match(')');
				return(v);
			}
			if(isAlpha(c)) 
			{
				var f:String = getFunctionName();				
				if( !isNaN(Math[f]) )
				{  // a constant
					stack.push(f);
					return(Math[f]);
				}
				// otherwise, it's a function
				match('(');
				v = getExpression();
				match(')');
				if(logBaseXFlag)
				{
					//calculate
					var no1:Number=v;
					trace(no1);
					var no2:Number=newV;
					trace(no2);
					var calcValue:Number=0;
					calcValue=Math.log(no2)/Math.log(no1);
					stack.push(f);
					logBaseXFlag=false;
					
					return( calcValue );
				}
				else
				{
					stack.push(f);
					return( Math[f](v) );
				}
				
			}
			var s:String = '';
			if('x+-'.indexOf(c) > 0) 
			{
				s += c;
				match(c);
			}
			while(isNumChar(c)) 
			{	// isNumChar matches digits and decimal point
				s += c;
				match(c);
			}
			if(isNaN(Number(s))) 
			{
				trace("Error : '" + s + "' is not a number.");
				return;
			}
			stack.push(Number(s));
			return(Number(s))
		}
		
		public function getFunctionName() 
		{
			var s : String = '';
			while(isAlphaNumeric(c)) 
			{
				s += c;
				match(c);
			}
			if (!isNaN( Math[s.toUpperCase()]) ) 
			{ // a number
				return(s.toUpperCase());
			}
			if(isLogBaseX(s))
			{
				logBaseXFlag=true;
				return(s.toLowerCase());
			}
			else if( Math[s.toLowerCase()] instanceof Function  ) 
			{ // a function
				return(s.toLowerCase());
			}
			error("Error: unknown function '" + s + "'");
			return("???");
		}
		
		/*public function isOtherFunction(s:String):Boolean
		{
		if(isLogBaseX(s))
		return true;
		else
		return false;
		}*/
		public function isLogBaseX(s:String):Boolean
		{
			var flag:Boolean=false;
			var logStr = s.substr(0,3);
			if(s.toLowerCase() =="log" && s.length>3)
			{
				var str:String=s.substr(3);
				if(!isNaN(Number(str)))
				{
					newV = Number(str);
					flag=true;
				}
			}
			return flag;
		}
		
		public function eatWhiteSpace() 
		{
			while(c == ' ' || c == "\t") 
			{
				match(c);
			}
		}
		
		public function match(cc:String) 
		{
			if(inString.charAt(i) != cc) 
			{
				trace("Match error: expected '" + cc + "' but got '" + inString.charAt(i) + "'");
				return;
			}
			// get the next character
			c = inString.charAt(++i);
		}
		
		public function isNumChar(c:String) 
		{
			return('x0123456789.'.indexOf(c) > 0);
		}
		
		public function isAlpha(x) 
		{
			return(' 0123456789abcdefghijklmnopqrstuvwxyz'.indexOf(x) > 10);
		}
		
		public function isAlphaNumeric(x) 
		{
			return(' 0123456789abcdefghijklmnopqrstuvwxyz'.indexOf(x) > 0);
		}
		
		public function removeJunkString() 
		{
			clearInterval(removeInt);
			var pos = view.numDisplay.text.indexOf(junkString);
			if(pos < 0) return;
			view.numDisplay.text = view.numDisplay.text.substr(0, pos);
		}
		
		public function error(msg) 
		{
			trace(msg);
			if(errorMessage != '') 
			{
				errorMessage += "  |  ";
			}
			errorMessage += msg;
		}
		private function clearClicked(e:MouseEvent):void
		{			
			clearAll();	
		}
		private function ceClicked(event:MouseEvent):void
		{			
			view.resultDisplay.text="0";			
		}
		private function clear():void
		{			
			digitFlag = false;	
			view.numDisplay.text="";	
		}
		private function clearAll():void
		{			
			clear();
			view.numDisplay.text="0";		
			view.resultDisplay.text="";	
			
		}
		
		private function backClicked(event:MouseEvent):void
		{
			var no:String=view.numDisplay.text;
			if(no=="0")
			{
				var no1:String=view.numDisplay.text;
				if(no1.length>1)
					no1 = no1.substr(0,no1.length-1);
				else
					no1="0";
				view.numDisplay.text = no1;
			}
			
			if(no.length>1)
				no = no.substr(0,no.length-1);
			else
				no="0";
			view.numDisplay.text = no;
			
		}
		private function dotClicked(event:MouseEvent):void
		{
			digitFlag=false;
			var no:String=view.numDisplay.text;
			if(no=="") no="0";
			var lastChar:String = no.charAt(no.length-1);
			//if(isOperator(lastChar)) no=no+"0";
			if(!dotFlag)
			{
				view.numDisplay.text= no+".";
			}
			digitFlag =true;
			dotFlag=true;
		}
		
	}
}